----------------------------------
--	Aurora Borealis (vesa)	--
--	By Sharachan Feb 2005	--
--				--
--	No copyrights		--
--	ban@epost.no		--
----------------------------------




without type_check

include neil.e
include get.e
include misc.e
include machine.e



atom junk,gk,ygh,many,ax,ay,cx,cy,work
junk = vesa_mode(640,480,32)
	if junk = 1 then junk = vesa_mode(640,480,24) end if
gk=get_key()
many=2
sequence s,polx,poly,posx,posy,xdir,ydir,stepx,stepy
polx=repeat(0,many)
poly=repeat(0,many)
posx=repeat(0,many)
posy=repeat(0,many)
xdir=repeat(0,many)
ydir=repeat(0,many)
stepx=repeat(0,many)
stepy=repeat(0,many)

s=repeat(0,250)
for z = 1 to many do
polx[z]=repeat(0,250)
poly[z]=repeat(0,250)


xdir[z]=PI/2
ydir[z]=PI
stepx[z]=(rand(30)+05)/1000
stepy[z]=(rand(20)+05)/-1000
posx[z]=320
posy[z]=240
end for
for z= 1 to 25 do
	s[z]={       z	,z 	,0}
	s[z+25]={ 25+z	,25-z	,0}
	s[z+50]={ 50+z	,z	,0}
	s[z+75]={ 75+z	,25+z	,0}
	s[z+100]={100-z	,50+z	,0}
	s[z+125]={75-z	,75+z  ,0}
	s[z+150]={50-z	,100-z	,0}
	s[z+175]={25-z	,75-z   ,0}
	s[z+200]={z	,50-z   ,0}
	s[z+225]={25-z	,25-z   ,0}
end for
s[1]={0,0,0}
color_convert(1)
make_rgb_map()
for zz = 1 to many do
for z = 1 to 250 do
	polx[zz][z]=posx[zz]
	poly[zz][z]=posy[zz]
end for
end for
work=virtual_screen(640,480)

procedure move()
	for zz = 1 to many do
	for z= 1 to 249 do
		polx[zz][z]=polx[zz][z+1]
		poly[zz][z]=poly[zz][z+1]
	end for

	polx[zz][250]=posx[zz]
	poly[zz][250]=posy[zz]
end for
end procedure

procedure calc()
for zz = 1 to many do
    posx[zz]=posx[zz]+(sin(xdir[zz])*3)
    posy[zz]=posy[zz]+(cos(ydir[zz])*3)
if posx[zz] >639 then posx[zz] = 638 end if
if posx[zz] <1 then posx[zz] = 2 end if
if posy[zz] >479 then posy[zz] = 478 end if
if posy[zz] <1 then posy[zz] = 2 end if

if xdir[zz] > PI then
	xdir[zz]=-xdir[zz]
end if
xdir[zz]=xdir[zz]+stepx[zz]
if ydir[zz] > PI then
	ydir[zz]=-ydir[zz]
end if
ydir[zz]=ydir[zz]+stepy[zz]
end for
end procedure
procedure draw()

	for z = 1 to 250 do
ax=floor(polx[1][z]) 
ay=floor(poly[1][z])
cx=floor(polx[2][z])
cy=floor(poly[2][z])
	draw_line(work,or_bits(s[z][1]*65536+s[z][2]*256+s[z][3],#010101), {{ax, ay}, {cx, cy}})
	end for
ygh = rand(50)
--if ygh > 45 then
--	pixel(255,{rand(1024),rand(768)})
--	pixel(254,{rand(1024),rand(768)})
--	pixel(rand(255),{rand(1024),rand(768)})
--end if
do_command(screen_blit, work, {screen,0,0})
end procedure

while gk!=27 do
gk=get_key()
calc()
move()
draw()
end while

restore_mode()



